function [x_star, fn_star, ne, nrst]= debr18(fn_name, a, b, my_eps, max_evals, N, n0, delta)
% Tvrdik, March  2006
d=length(a);  h=18; % number of settings in competition
if nargin ~= 8
    N=max([20, 2*d]); n0=2; delta=1/(5*18);  % h = 18
end
if nargin==3
    my_eps=1e-7;  max_evals=20000;
end
% initialization
P=zeros(N,d+1);
for i=1:N
    P(i,1:d)=a+(b-a).*rand(1,d);
    P(i,d+1)=feval(fn_name,(P(i,1:d)));
end  % 0-th generation initialized
fmax=max(P(:,d+1));
[fmin, indmin]=min(P(:,d+1));
ni=zeros(1,h)+n0;  nrst=0;  ne=N;
Q=P;
while (fmax-fmin > my_eps) && (ne < d*max_evals)  % main loop
    for i=1:N  %  in each generation
        [hh p_min]=roulete(ni); % select hh-th set of parameters
        if p_min<delta
            ni=zeros(1,h)+n0;
            nrst=nrst+1;
        end  %reset
        switch hh % number of selected heuristic
            case 1
                F=0.5; CR=0; y=debest(P,F,CR,[i,indmin]);
            case 2
                F=0.5; CR=0.5; y=debest(P,F,CR,[i,indmin]);
            case 3
                F=0.5; CR=1; y=debest(P,F,CR,[i,indmin]);
            case 4
                F=0.8; CR=0; y=debest(P,F,CR,[i,indmin]);
            case 5
                F=0.8; CR=0.5; y=debest(P,F,CR,[i,indmin]);
            case 6
                F=0.8; CR=1;  y=debest(P,F,CR,[i,indmin]);
            case 7
                F=1; CR=0;  y=debest(P,F,CR,[i,indmin]);
            case 8
                F=1; CR=0.5; y=debest(P,F,CR,[i,indmin]);
            case 9
                F=1; CR=1;  y=debest(P,F,CR,[i,indmin]);
            case 10
                F=0.5; CR=0;   y=derand(P,F,CR,i);
            case 11
                F=0.5; CR=0.5;   y=derand(P,F,CR,i);
            case 12
                F=0.5; CR=1;   y=derand(P,F,CR,i);
            case 13
                F=0.8; CR=0;   y=derand(P,F,CR,i);
            case 14
                F=0.8; CR=0.5;   y=derand(P,F,CR,i);
            case 15
                F=0.8; CR=1;   y=derand(P,F,CR,i);
            case 16
                F=1; CR=0;   y=derand(P,F,CR,i);
            case 17
                F=1; CR=0.5;   y=derand(P,F,CR,i);
            case 18
                F=1; CR=1;    y=derand(P,F,CR,i);
        end
        y=zrcad(y,a,b);     % perturbation
        fy=feval(fn_name,y);
        ne=ne+1;
        if fy < P(i,d+1)  % trial point y is good for renewing population
            Q(i,:)= [y fy];
            ni(hh)=ni(hh)+1;         % change of qi
        end
    end % end of generation
    P=Q;
    fmax=max(P(:,d+1));
    [fmin,indmin]=min(P(:,d+1));
end   % main loop - end
x_star=P(indmin,1:d);
fn_star=fmin;
%